#ifndef P4COMMANDRUNNER_H
#define P4COMMANDRUNNER_H

#include "clientapi.h"
#include <enviro.h>

#include "p4connection.h"

#include <QObject>
#include <QStringList>
#include <QVariantMap>

#include <QThread>
#include <QtConcurrentRun>
#include <QFuture>
#include <QFutureWatcher>

class P4CommandRunner : public QObject
{
    Q_OBJECT

public:
    P4CommandRunner(P4Connection* caller, QVariantList args);
    virtual ~P4CommandRunner() {}

    QString getInputData() {return m_InputData;}
    Q_INVOKABLE void    setInputData(QString inputData) {m_InputData = inputData;}

    Q_INVOKABLE QVariant exec();

    Q_INVOKABLE void execBG();
    Q_INVOKABLE void destroy();

    QStringList* errorList() {return &m_ErrorList;}

signals:
    void runCompleted(QVariant responseData);

public slots:
    void deliverRunResponse();

private:
    P4Connection*   m_Caller;
    QString         m_Command;
    QVariantList    m_Args;
    QString         m_InputData;
    QStringList     m_ErrorList;

    QFuture<QVariant>*			m_Future;
    QFutureWatcher<void>*		m_Watcher;
};

#endif // P4COMMANDRUNNER_H
